ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.30 by root, Fri Feb 11 02:01:24 2011 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

10# perl build variables 10# perl build variables
11MAKE=make 11MAKE=make
12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -D_GNU_SOURCE -DNDEBUG" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-g -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
21 i*86 | x86_64 | amd64 ) 21 i*86 | x86_64 | amd64 )
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS 43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
51preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
52postconfigure() { : ; } 55postconfigure() { : ; }
53postbuild() { : ; } 56postbuild() { : ; }
54postinstall() { : ; } 57postinstall() { : ; }
55 58
56# now source user config, if any 59# now source user config, if any
63fi 66fi
64 67
65############################################################################# 68#############################################################################
66# support 69# support
67 70
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70 72
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
72LC_ALL=C; export LC_ALL # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
73 80
74# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
75VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
76$VERSION="1.0" 83$VERSION="1.21"
77 84
78BZ2=bz2 85BZ2=bz2
79BZIP2=bzip2 86BZIP2=bzip2
80 87
81fatal() { 88fatal() {
165unpacking perl 172unpacking perl
166EOF 173EOF
167 174
168 mkdir -p unpack 175 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION 176 rm -rf unpack/perl-$PERL_VERSION
170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
174 rmdir -p unpack 181 rmdir -p unpack
175 fi 182 fi
227 234
228 # I hate them for this 235 # I hate them for this
229 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231 238
232 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
233 244
234# trace configure \ 245# trace configure \
235 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
236 -Uuse64bitint \ 247 -Uuse64bitint \
237 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
260 -Usiteman3dir \ 271 -Usiteman3dir \
261 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
262 -Demail="$EMAIL" \ 273 -Demail="$EMAIL" \
263 -Dcf_email="$EMAIL" \ 274 -Dcf_email="$EMAIL" \
264 -Dcf_by="$EMAIL" \ 275 -Dcf_by="$EMAIL" \
265 -UDEBUGGING \
266 $PERL_CONFIGURE \ 276 $PERL_CONFIGURE \
267 -Duseperlio \ 277 -Duseperlio \
268 -dE || configure_failure 278 -dE || configure_failure
269 279
270 sedreplace ' 280 sedreplace '
271 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
272 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
273 ' config.sh 283 ' config.sh
274 284
285 patchconfig || fatal "patchconfig hook failed"
286
275 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
276 288
277 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
278 290
279 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
280} 303}
281 304
282build() { 305build() {
283 configure 306 configure
284 307
305EOF 328EOF
306 329
307 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
308 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
309 332
333 mkdir "$STATICPERL/patched"
334
310 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
311 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
312 337
313 "$MAKE" install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
314 339
315 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
316 341
317 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
318 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
319"$MAKE" || exit 344#CAT make-install-make.sh
320
321if find blib/arch/auto -type f | grep -q -v .exists; then
322 echo Probably an XS module, rebuilding perl
323 if "$MAKE" perl; then
324 mv perl "$PERL_PREFIX"/bin/perl~ \
325 && rm -f "$PERL_PREFIX"/bin/perl \
326 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
327 "$MAKE" -f Makefile.aperl map_clean
328 else
329 "$MAKE" -f Makefile.aperl map_clean
330 exit 1
331 fi
332fi
333
334"$MAKE" install UNINST=1
335EOF 345EOF
336 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
337 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
338 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
339 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
340 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
341 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
342 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
343 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
344 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
345 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
346 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
347 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
348 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
349 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
350 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
351 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
352 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
353 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
354 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
355 375
356 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
357 fi 377 fi
377installing modules from CPAN 397installing modules from CPAN
378$@ 398$@
379EOF 399EOF
380 400
381 for mod in "$@"; do 401 for mod in "$@"; do
382 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
383 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
384 done 404 done
385 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
386} 406}
387 407
403 rcd $mod 423 rcd $mod
404 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
405 "$MAKE" distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
406 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
407 "$MAKE" || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
408 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
409 "$MAKE" distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
410 exit 0 430 exit 0
411 ) || exit $? 431 ) || exit $?
412 done 432 done
413} 433}
445#CAT mkbundle 465#CAT mkbundle
446MKBUNDLE 466MKBUNDLE
447} 467}
448 468
449bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
450 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
451 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
452 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
453 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
454 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
473 ;; 494 ;;
474 instcpan ) 495 instcpan )
475 ( instcpan "$@" ) || exit 496 ( instcpan "$@" ) || exit
476 exit 497 exit
477 ;; 498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
502 exit
503 ;;
478 cpan ) 504 cpan )
479 ( install ) || exit 505 ( install ) || exit
480 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
481 exit 507 exit
482 ;; 508 ;;
483 mkbundle ) 509 mkbundle )
484 ( install ) || exit 510 ( install ) || exit
485 bundle "$@" 511 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines